// SCI.c  has procedures for input and output through the SCI on
// a 68HC11.

#include <Include\bittest.c>
char c;
int a;

void InitSerial()
{
  poke(0x102b, 0b00110000);
  poke(0x102d, 0b00001100);
}

void NewLine()
{
  c = 0x0a;
  OutCh();
  c = 0x0d;
  OutCh();
}

void print()
{
  asm("ldaa   0,y");
  asm("beq    printx");
  asm("staa   c+1");
  OutCh();
  asm("iny");
  asm("bra    _print");
#label printx;
}

void OutCh()
{
  asm("ldx    #$1000");
  do()
    peek(0x102e) => a;
    BitTest(a, 0b10000000) => a;
  while(a == 0);
  asm("ldx    #$1000");
  asm("ldaa   c+1");
  asm("staa   $2f,x")
}

void InKey()
{
    peek(0x102e) => a;
    BitTest(a, 0b00100000) => a;
    if(a == 0)
    {
      c = 0;
      aclbl(doneInKey);
    }

  asm("ldx    #$1000");
  asm("ldaa   #$00");
  asm("ldab   $2f,x");

  asm("std    c");
#label doneInKey;
}
