// SCIRec.c
// don't forget to download SCI.c and ITOA.c (these files are included in the SCIRec.zip file)

#include <sci.c>
#include <itoa.c>

long point,savePoint;
char mode;

int pauseMax, counter;

int button;
BOOL rstButton;

void InKeyWait(echo)
{
  do()
    InKey() => c;
  while(c == 0x00);

  if(echo == true)
  {
    OutCh();
  }
}

void CheckNote()
{
  poke(0x1030, 0b00000000);
  AD_delay();
  peek(0x1031) => button;

  if(button > 100)
  {
    if(rstButton == true)
    {
      rstButton = false;
      loadX(point);
      loadA(#$ff);
      storeA($00,x);
      point ++;
    }
  }
  else
  {
    rstButton = true;
  }
}

void Record()
{
  do()
    InKeyWait(FALSE);
    loadX(point);
    loadA(c+1);
    storeA($00,x);
    point ++;
    CheckNote();
    savePoint = point;
  while(1);
}

void CheckPause()
{
    if(mode == "c")
    {
      InKeyWait(FALSE);
    }
    else if(mode == "w")
    {
      if(c == 0x20)
      {
        InKeyWait(FALSE);
      }
    }
    else if(mode == "p")
    {
      counter ++;
      if(counter == pauseMax)
      {
        counter = 0;
        InKeyWait(FALSE);
      }
    }
}

void List()
{
  do()
#label again;
    loadX(point);
    loadA(0);
    loadB($00,x);
    storeD(c);
    if(c == 0xff)
    {
      point ++;
      aclbl(again);
    }
    OutCh();

    CheckPause();

    point ++;
  until(point == savePoint);
}

void FindNote()
{
  do()
    loadX(point);
    loadA(0);
    loadB($00,x);
    storeD(c);
    point ++;
    if(c == 0xff)
    {
      break();
    }
  until(point == savePoint);

  if(point == savePoint)
  {
    point = 0x9000;
  }
}

main()
{
  point = 0x8000;
  pauseMax = 20;
  poke(0x1039, 0b10000000);
  button = 0;
  rstButton = true;
  counter = 0;
  // right here:
  mode = "c";
  InitSerial();
  loadY(#_Msg1);
  print();

  InKeyWait(TRUE);

  if(c == "r")
  {
    Record();
  }

  do()
    if(c == "c")
    {
      mode = "c";
    }
    else if(c == "w")
    {
      mode = "w";
    }
    else if(c == "n")
    {
      FindNote();
    }
    else if(c == "p")
    {
      mode = "p";
    }
    else if(c == "l")
    {
      List();
      asm("jmp    _main");
    }
    InKeyWait(TRUE);
  while(1);
}

void beep()
{
}

void Msg1()
{
  asm_direct(    fcc     "SCI Recorder is Running")
  asm("fcb    $0a,$0d");
  asm("fcb    0");
